---
### In order to finish:  ###
### 1. Make a review     ###
### 2. secured-post... ###
### 3. Create the files: ###
### rootCA.pem,devCA.pem ###

- hosts: localhost
  gather_facts: no
  vars:
    k8s_host: "https://api.{{ cluster_name }}.{{ base_domain }}:6443"
    openshift_custom_certificates: true

  tasks:
    - name: Incuding role
      import_role:
        name: role-get-ocp-token
      vars: 
        ca_cert: 'files/rootCA.crt'
     
    - name: getting ServiceAccount token
      shell: 'oc serviceaccounts get-token argocd-manager -n kube-system --token={{ ocp_token }} -s {{ k8s_host }} '
      register: argocd_manager_token  
      
    - name: create ServiceAccount argocd-manager in kube-system
      k8s:
        api_key: "{{ ocp_token }}"
        host: "{{ k8s_host }}"
        validate_certs: "{{ validate_ssl }}"
        definition: "{{ lookup('file', './serviceaccount.yaml') }}"
        state: present

    - name: create ClusterRole argocd-manager-role
      k8s:
        api_key: "{{ ocp_token }}"
        host: "{{ k8s_host }}"
        validate_certs: "{{ validate_ssl }}"
        definition: "{{ lookup('file', './clusterrole.yaml') }}"
        state: present

    - name: create ClusterRoleBinding argocd-manager-role-binding
      k8s:
        api_key: "{{ ocp_token }}"
        host: "{{ k8s_host }}"
        validate_certs: "{{ validate_ssl }}"
        definition: "{{ lookup('file', './clusterrolebinding.yaml') }}"
        state: present

    - name: getting all connected clusters
      uri:
        url: '{{ argocd_server }}/api/v1/clusters'
        method: GET
        headers:
          Content-Type: "application/json"
          Cookie: "argocd.token={{ argocd_token }}"
        body_format: json
        validate_certs: no
      register: quavo
      
    - name: filtering quavo and making servers + insecure values dict ans server names list for later conditions
      set_fact:
        server_names: "{{ server_names | default([]) + [item.server] }}"
        servers_insecure: "{{ servers_insecure | default([]) + [ {'server': item.server, 'insecure': item.config.tlsClientConfig.insecure} ] }}"
      loop: "{{ quavo['json']['items'] }}"
      
    - name: validating the dict
      debug:
        var: servers_insecure


    - name: condition 1 - server already has a connection and openshift var is true
      block:
              ## Need to reconneced with secure

        - name: subcondition - server has insecure connection
          when: item.server == k8s_host and item.insecure
          loop: "{{ servers_insecure }}"
          include_tasks: tasks/secured-post.yml
          

        
        - name: subcondition - server has secure connection
          debug:
         ## Desired state
            msg: "server {{ k8s_host }} has secured connection. no vars conflicts. all good!"
          when: item.server == k8s_host and not item.insecure
          loop: "{{ servers_insecure }}"

      when: k8s_host in server_names and openshift_custom_certificates
    

    - name: condition 2 - server already has a connection and openshift var is false
      block:
    
        - name: subcondition - server has insecure connection
          debug:
          ## Desired state
            msg: "server {{ k8s_host }} has insecure connection, but var is false so all good"
          when: item.server == k8s_host and item.insecure
          loop: "{{ servers_insecure }}"
        
        - name: subcondition - server has secure connection
          debug:
          ## In case of secured connection and requirement of it to be unsecure, nothing happens
            msg: "server {{ k8s_host }} has secured connection, var is false. VARS CONFILCT!!"
          when: item.server == k8s_host and not item.insecure
          loop: "{{ servers_insecure }}"

      when: k8s_host in server_names and not openshift_custom_certificates
   
    - name: condition 3 - server doesn't have connection
      block:
    
        - name: subcondition - openshift var is true
          #  The cluster needs to configure secure connection"
          import_tasks: tasks/secured.yml
          when: openshift_custom_certificates
        
        - name: subcondition - openshift var is false
           # The Cluster needs to configure insecure connection"
          import_tasks: tasks/unsecured.yml
          when: not openshift_custom_certificates
      when: k8s_host not in server_names

     
      
